<?php
/**
 * SENAYAN application printable data configuration
 *
 * Copyright (C) 2007,2008  Arie Nugraha (dicarve@yahoo.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

// label print settings
/* measurement in cm */
$page_margin = 0.2;
$items_per_row = 3;
$items_margin = 0.05;
$box_width = 8;
$box_height = 3.3;
$include_header_text = 1; // change to 0 if dont want to use header in each label
$header_text = ''; // keep empty if you want to use Library Name as a header text
$fonts = "Arial, Verdana, Helvetica, 'Trebuchet MS'";
$font_size = 11;
$border_size = 1; // in pixels

// item barcode print settings
/* measurement in cm */
$barcode_page_margin = 0.2;
$barcode_items_per_row = 3;
$barcode_items_margin = 0.1;
$barcode_box_width = 7;
$barcode_box_height = 5;
$barcode_include_header_text = 1; // change to 0 if dont want to use header in each barcode
$barcode_cut_title = 50; // maximum characters in title to appear in each barcode. change to 0 if you dont want the title cutted
$barcode_header_text = ''; // keep empty if you want to use Library Name as a header text
$barcode_fonts = "Arial, Verdana, Helvetica, 'Trebuchet MS'"; // font to use
$barcode_font_size = 11;
$barcode_scale = 70; // barcode scale in percent relative to box width and height
$barcode_border_size = 1; // in pixels

// member card print settings
/* measurement in cm */
$card_page_margin = 0.2;
$card_items_per_row = 2;
$card_items_margin = 0.1;
$card_box_width = 12;
$card_box_height = 6;
$card_header_text = $sysconf['library_name'];
$card_photo_width = 3;
$card_photo_height = 3;
$card_fonts = "Arial, Verdana, Helvetica, 'Trebuchet MS'"; // font to use
$card_font_size = 11;
$card_barcode_scale = 70; // barcode scale in percent relative to box width and height
$card_include_field_label = 1; // set 0 if you don't want to show field label in card
$card_border_size = 1; // in pixels

// barcode generator print settings
$barcodegen_box_width = 6;
$barcodegen_page_margin = 0.2;
$barcodegen_items_margin = 0.05;
$barcodegen_include_border = 0;

/* Receipt Printing */
$receipt_width = '15cm';
$receipt_font = 'serif';
$receipt_color = '#000';
$receipt_margin = '5px';
$receipt_padding = '5px';
$receipt_border = '1px dashed #000';
$receipt_fontSize = '7pt';
$receipt_header_fontSize = '8pt';
$receipt_titleLength = 100;

?>
